package test.forum.json;

import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

import org.eclipse.persistence.jaxb.JAXBContextFactory;
import org.eclipse.persistence.jaxb.JAXBContextProperties;
import org.eclipse.persistence.jaxb.MarshallerProperties;
import org.eclipse.persistence.jaxb.UnmarshallerProperties;
import org.eclipse.persistence.oxm.MediaType;

public class BindingsTester {

    
    public static void main(String[] args) throws Exception{
        Map<String, Object> props = new HashMap<String, Object>();        
        InputStream bindingsInput = Thread.currentThread().getContextClassLoader().getResourceAsStream("./test/forum/json/bindings.xml"); 
        props.put(JAXBContextProperties.OXM_METADATA_SOURCE, bindingsInput);
        JAXBContext ctx = JAXBContextFactory.createContext(new Class[]{OprAny.class, OprEvtStatistics.class, OprEvtStatisticRecord.class, OprResourceBase.class}, props);
        Unmarshaller u = ctx.createUnmarshaller();
        u.setProperty(UnmarshallerProperties.MEDIA_TYPE, MediaType.APPLICATION_JSON);
        u.setProperty(UnmarshallerProperties.JSON_ATTRIBUTE_PREFIX, "@");

        InputStream is = Thread.currentThread().getContextClassLoader().getResourceAsStream("./test/forum/json/in_modified.json");
        Object unmarshalled = u.unmarshal(is);        
      
        Marshaller m = ctx.createMarshaller();
        m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
        m.setProperty(MarshallerProperties.MEDIA_TYPE, MediaType.APPLICATION_JSON);
        m.setProperty(MarshallerProperties.JSON_ATTRIBUTE_PREFIX, "@");
        m.marshal(unmarshalled, System.out);

    }

}
