package test.forum.json;

import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

import org.eclipse.persistence.jaxb.JAXBContextFactory;
import org.eclipse.persistence.jaxb.MarshallerProperties;
import org.eclipse.persistence.jaxb.UnmarshallerProperties;
import org.eclipse.persistence.oxm.MediaType;

public class JSONTester {

// json main -  xml main is below
  public static void main(String[] args) throws Exception {
    JAXBContext ctx = JAXBContextFactory.createContext(new Class[]{OprAny.class, OprEvtStatistics.class, OprEvtStatisticRecord.class, OprResourceBase.class}, null);
    Unmarshaller u = ctx.createUnmarshaller();

    u.setProperty(UnmarshallerProperties.JSON_NAMESPACE_PREFIX_MAPPER, getNamespacePrefixes());
    u.setProperty(UnmarshallerProperties.JSON_NAMESPACE_SEPARATOR, ':');
    u.setProperty(UnmarshallerProperties.JSON_ATTRIBUTE_PREFIX, "@");
    u.setProperty(UnmarshallerProperties.JSON_INCLUDE_ROOT, true);
    u.setProperty(UnmarshallerProperties.MEDIA_TYPE, MediaType.APPLICATION_JSON);

    InputStream is = Thread.currentThread().getContextClassLoader().getResourceAsStream("./test/forum/json/stats.json");
    Object unmarshalled = u.unmarshal(is);

    Marshaller m = ctx.createMarshaller();

    m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
    m.setProperty(MarshallerProperties.NAMESPACE_PREFIX_MAPPER, getNamespacePrefixes());
    m.setProperty(MarshallerProperties.JSON_NAMESPACE_SEPARATOR, ':');
    m.setProperty(MarshallerProperties.JSON_ATTRIBUTE_PREFIX, "@");
    m.setProperty(MarshallerProperties.MEDIA_TYPE, MediaType.APPLICATION_JSON);

    m.marshal(unmarshalled, System.out);
  }

//  // xml main - for json main see above
//  public static void main(String[] args) throws Exception {
//    JAXBContext ctx = JAXBContextFactory.createContext(new Class[]{OprAny.class, OprEvtStatistics.class, OprEvtStatisticRecord.class, OprResourceBase.class}, null);
//    Unmarshaller u = ctx.createUnmarshaller();
//
//    u.setProperty(UnmarshallerProperties.AUTO_DETECT_MEDIA_TYPE, Boolean.TRUE);
//    u.setProperty(UnmarshallerProperties.MEDIA_TYPE, MediaType.APPLICATION_XML);
//
//    InputStream is = Thread.currentThread().getContextClassLoader().getResourceAsStream("./test/forum/json/stats.xml");
//    Object unmarshalled = u.unmarshal(is);
//
//    Marshaller m = ctx.createMarshaller();
//
//    m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
//    m.setProperty(MarshallerProperties.NAMESPACE_PREFIX_MAPPER, getNamespacePrefixes());
//
//    m.setProperty(Marshaller.JAXB_FRAGMENT, Boolean.TRUE);
//    m.setProperty(MarshallerProperties.MEDIA_TYPE, MediaType.APPLICATION_XML);
//
//    m.marshal(unmarshalled, System.out);
//  }

  public final static Map<String, String> getNamespacePrefixes() {
    Map<String, String> prefixMap = new HashMap<String, String>();
//    prefixMap.put(OprResourceBase.NAMESPACE, "");
    prefixMap.put("http://www.w3.org/2001/XMLSchema-instance", "xsi");
    prefixMap.put("http://www.w3.org/2001/XMLSchema", "xs");
    return prefixMap;
  }

}
