package test.forum.json;

import java.net.URI;
import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

@XmlRootElement(name = OprEvtStatisticsType.XML_NAME)
@XmlType(name = OprEvtStatisticsType.XML_TYPE)
@XmlEnum(String.class)
public enum OprEvtStatisticsType
{
  RECEIVED,
  CLOSED_BY_EPI,
  CLOSED_BY_PAIRWISE,
  CLOSED_BY_AUTOMATION,
  CLOSED_BY_SBEC,
  CORRELATED_BY_TBEC,
  CORRELATED_BY_SBEC,
  DISCARDED_BY_DEDUP,
  DISCARDED_BY_SBEC,
  DISCARDED_BY_EPI,
  DISCARDED_BY_EVENTSTORM,
  DISCARDED_BY_EVENTAGE;

  public static final String VERSION = "1.0";

  public static final String XML_NAME = "event_statistics_type";
  public static final String XML_TYPE = XML_NAME + "_type";
  public static final String TYPE = OprEvtStatistics.TYPE + ":" + XML_NAME;
  public static final URI TYPE_URI = URI.create(TYPE);
  public static final String TAXONOMY = OprResourceBase.BASE_TAXONOMY + OprEvtStatistics.XML_NAME + ":" + XML_NAME;
  public static final URI TAXONOMY_URI = URI.create(TAXONOMY);

  public static OprEvtStatisticsType fromString(String name)
  {
    return valueOf(name.toUpperCase());
  }
}
